{ Copyright (C) <2020> <Bernd Hübner>>

  This library is free software; you can redistribute it and/or modify it under the
  terms of the GNU Library General Public License as published by the Free Software
  Foundation; either version 2 of the License, or (at your option) any later
  version with the following modification:

  As a special exception, the copyright holders of this library give you permission
  to link this library with independent modules to produce an executable,
  regardless of the license terms of these independent modules,and to copy and
  distribute the resulting executable under terms of your choice, provided that you
  also meet, for each linked independent module, the terms and conditions of the
  license of that module. An independent module is a module which is not derived
  from or based on this library. If you modify this library, you may extend this
  exception to your version of the library, but you are not obligated to do so. If
  you do not wish to do so, delete this exception statement from your version.

  This program is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
  PARTICULAR PURPOSE. See the GNU Library General Public License for more details.

  You should have received a copy of the GNU Library General Public License along
  with this library; if not, write to the Free Software Foundation, Inc., 51
  Franklin Street - Fifth Floor, Boston, MA 02110-1335, USA.
}


unit easytranslation;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils;
type
  TLanguage = (de,en);

  function  TransText(aIdx:Integer;aLanguage:TLanguage):string;

implementation


function TransText(aIdx:Integer;aLanguage:TLanguage): string;
  begin
   case aIdx of
    0:  begin
         if aLanguage = de then result:= 'Kopieren';
         if aLanguage = en then result:= 'Copy';
        end;
    1:  begin
         if aLanguage = de then result:= 'Ausschneiden';
         if aLanguage = en then result:= 'Cut';
        end;
    2:  begin
         if aLanguage = de then result:= 'Einfügen';
         if aLanguage = en then result:= 'Paste';
        end;
    21: begin
         if aLanguage = de then result:= 'Einpassen';
         if aLanguage = en then result:= 'Fit In';
        end;
    3:  begin
         if aLanguage = de then result:= 'Löschen';
         if aLanguage = en then result:= 'Delete';
        end;
    4:  begin
         if aLanguage = de then result:= 'Transparent';
         if aLanguage = en then result:= 'Transparent';
        end;
    5:  begin
         if aLanguage = de then result:= 'Transparentefarbe setzen';
         if aLanguage = en then result:= 'Set Transparent Color';
        end;
    51: begin
         if aLanguage = de then result:= 'Transparentefarbe auswählen';
         if aLanguage = en then result:= 'Choose Transparent Color';
        end;
    52: begin
         if aLanguage = de then result:= 'Transparentefarbe scannen';
         if aLanguage = en then result:= 'Scan Transparent Color';
        end;
    6:  begin
         if aLanguage = de then result:= 'Hintergrund löschen';
         if aLanguage = en then result:= 'Erase Background';
        end;
    7:  begin
         if aLanguage = de then result:= 'Auswahloptionen';
         if aLanguage = en then result:= 'Selection Options';
        end;
    71: begin
         if aLanguage = de then result:= 'Alles Auswählen';
         if aLanguage = en then result:= 'Select All';
        end;
    72: begin
         if aLanguage = de then result:= 'Rechteckige Auswahl';
         if aLanguage = en then result:= 'Rectangular Selection';
        end;
    73: begin
         if aLanguage = de then result:= 'Quadratische Auswahl';
         if aLanguage = en then result:= 'Square Selection';
        end;
    74: begin
         if aLanguage = de then result:= 'Formfreie Auswahl';
         if aLanguage = en then result:= 'Form-Free Selection';
        end;
    8 : begin
         if aLanguage = de then result:= 'Drehen';
         if aLanguage = en then result:= 'Rotate';
        end;
    81: begin
         if aLanguage = de then result:= 'Rechts Drehen';
         if aLanguage = en then result:= 'Rotate Right';
        end;
    82: begin
         if aLanguage = de then result:= 'Links Drehen';
         if aLanguage = en then result:= 'Rotate Left';
        end;
    83: begin
         if aLanguage = de then result:= 'um 180° Drehen';
         if aLanguage = en then result:= 'Rotate 180°';
        end;
    84: begin
         if aLanguage = de then result:= 'Horizontal Spiegeln';
         if aLanguage = en then result:= 'Flip Horizontally';
        end;
    85: begin
         if aLanguage = de then result:= 'Vertikal Spiegeln';
         if aLanguage = en then result:= 'Flip Vertically';
        end;
    9:  begin
         if aLanguage = de then result:= 'Größe ändern';
         if aLanguage = en then result:= 'Set Size';
        end;
    91: begin
         if aLanguage = de then result:= 'Aktuelle Größe (B/H): ';
         if aLanguage = en then result:= 'Actual Size (w/h): ';
        end;
    92: begin
         if aLanguage = de then result:= 'Neue Größe eingeben: ';
         if aLanguage = en then result:= 'Set New Size: ';
        end;
    93: begin
         if aLanguage = de then result:= 'Breite: ';
         if aLanguage = en then result:= 'Width: ';
        end;
    94: begin
         if aLanguage = de then result:= 'Höhe: ';
         if aLanguage = en then result:= 'Height: ';
        end;
    95: begin
         if aLanguage = de then result:= 'Seitenverhältnis beibehalten';
         if aLanguage = en then result:= 'XXX';
        end;
    96: begin
         if aLanguage = de then result:= 'Bitte wählen: ';
         if aLanguage = en then result:= 'XXX: ';
        end;
    97: begin
         if aLanguage = de then result:= 'Zuschneiden';
         if aLanguage = en then result:= 'XXX';
        end;
    10: begin
         if aLanguage = de then result:= 'als transp. PNG speichern';
         if aLanguage = en then result:= 'save as transp. PNG';
        end;
    11: begin
         if aLanguage = de then result:= 'Abbrechen';
         if aLanguage = en then result:= 'Abort';
        end;
    12: begin
         if aLanguage = de then result:= 'Fertigstellen';
         if aLanguage = en then result:= 'Finished';
        end;
   end;//case
  end;


end.

